import {Routes} from '@angular/router';
import {AuthLayoutComponent} from './core';
import {AdminLayoutComponent} from './core/admin-layout/admin-layout.component';

export const AppRoutes: Routes = [{
  path: '',
  component: AdminLayoutComponent,
  children: [{
    path: '',
    loadChildren: './components/user/user.module#UserModule'
  },
    {
      path: '',
      loadChildren: './components/basic/basic.module#BasicModule'
    },
    ]
}, {
  path: '',
  component: AuthLayoutComponent,
  children: [{
    path: 'auth',
    loadChildren: './auth/auth.module#AuthModule'
  }]
}, {
  path: '**',
  redirectTo: 'auth/404'
}];
