import {NgModule} from '@angular/core';
import {RouterModule} from '@angular/router';
import {CommonModule} from '@angular/common';
import {MatIconModule, MatCardModule, MatInputModule, MatCheckboxModule, MatButtonModule, MatSelectModule} from '@angular/material';
import {FormsModule, ReactiveFormsModule} from '@angular/forms';
import {FlexLayoutModule} from '@angular/flex-layout';
import {NgxSpinnerModule, NgxSpinnerService} from 'ngx-spinner';
import {LoadingModule} from 'ngx-loading';
import {AuthRoutes} from './auth.routing';
import {NotFoundComponent} from './not-found/not-found.component';
import {ErrorComponent} from './error/error.component';
import {ForgotComponent} from '../components/auth/forgot/forgot.component';
import {LockscreenComponent} from './lockscreen/lockscreen.component';
import {SigninComponent} from '../components/auth/signin/signin.component';
import {SubmitComponent} from '../components/auth/submit/submit.component';
import {NewPasswordComponent} from '../components/auth/newpassword/new-password.component';


@NgModule({
    imports: [
        LoadingModule.forRoot({
            backdropBackgroundColour: 'rgba(0,0,0,0.1)',
            backdropBorderRadius: '4px',
            primaryColour: '#0000ff',
            secondaryColour: '#0000ff',
            tertiaryColour: '#0000ff'
        }),
        LoadingModule,
        MatSelectModule,
        NgxSpinnerModule,
        CommonModule,
        RouterModule.forChild(AuthRoutes),
        MatIconModule,
        MatCardModule,
        MatInputModule,
        MatCheckboxModule,
        MatButtonModule,
        FlexLayoutModule,
        FormsModule,
        ReactiveFormsModule,
    ],
    declarations: [
        NotFoundComponent,
        ErrorComponent,
        ForgotComponent,
        LockscreenComponent,
        SigninComponent,
        SubmitComponent,
        NewPasswordComponent,
    ],
    providers: [NgxSpinnerService]

})

export class AuthModule {
}
