import {Injectable} from '@angular/core';

export interface BadgeItem {
    type: string;
    value: string;
}

export interface ChildrenItems {
    state: string;
    name: string;
    type?: string;
}

export interface Menu {
    state: string;
    name: string;
    type: string;
    icon: string;
    badge?: BadgeItem[];
    children?: ChildrenItems[];
}

const MENUITEMS = [
    {
        state: '/',
        name: 'صفحه اصلی ',
        type: 'link',
        icon: 'explore'
    },
    {
        state: 'user',
        name: 'مدیریت کاربران',
        type: 'sub',
        icon: 'account_circle',
        children: [
            {state: 'users', name: 'کاربران'},
            {state: 'roles', name: 'نقش ها'},
            {state: 'permissions', name: 'سظح دسترسی ها'}
        ]
    }, {
        state: 'basic',
        name: 'اطلاعات پایه',
        type: 'sub',
        icon: 'info',
        children: [

            {state: 'services', name: 'لیست خدمات'},
            {state: 'products', name: 'لیست محصولات'},
            {state: 'types', name: 'لیست نوع ها'},
        ]
    },


];

@Injectable()
export class MenuService {
    getAll(): Menu[] {
        return MENUITEMS;
    }

    add(menu: Menu) {
        MENUITEMS.push(menu);
    }
}
