"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
var ngx_cookie_service_1 = require("ngx-cookie-service");
var http_2 = require("@angular/http");
var DataTableFooterComponent = /** @class */ (function () {
    function DataTableFooterComponent(http, cookieService) {
        this.http = http;
        this.cookieService = cookieService;
        this.selectedCount = 0;
        this.page = new core_1.EventEmitter();
        // for test out put  for emit value of selected
        this.selectedValue = new core_1.EventEmitter();
        this.columnsArray = [];
    }
    Object.defineProperty(DataTableFooterComponent.prototype, "isVisible", {
        get: function () {
            return (this.rowCount / this.pageSize) > 1;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTableFooterComponent.prototype, "curPage", {
        get: function () {
            return this.offset + 1;
        },
        enumerable: true,
        configurable: true
    });
    DataTableFooterComponent.prototype.onClick = function (value) {
        this.selectedValue.emit(value);
    };
    DataTableFooterComponent.prototype.repairRows = function (arr) {
        var rv = [];
        for (var i = 0; i < arr.length; ++i)
            if (arr[i] !== undefined) {
                rv.push(Object.assign({}, arr[i]));
                return JSON.stringify(rv);
            }
    };
    DataTableFooterComponent.prototype.repaircolumns = function (arr) {
        for (var key in arr) {
            var obj = {
                columns: this.columns[key]['prop'],
                name: this.columns[key]['name'],
            };
            this.columnsArray.push(obj);
        }
        return JSON.stringify(this.columnsArray);
    };
    DataTableFooterComponent.prototype.exportExcel = function () {
        var token = this.cookieService.get('token');
        var headers = new http_2.Headers();
        headers.append('Content-Type', 'application/x-www-form-urlencoded\n');
        headers.append('Authorization', 'Bearer ' + token);
        // return this.http.post(this.appUrl + 'excel', 'type=' + 'excel' +
        //   '&filters=' + JSON.stringify(this.filters) + '&columns=' + this.repaircolumns(this.columns) + '&sortDir=' + this.sortDir +
        //   '&sortProp=' + this.sortProp + '&includes=' + this.includes + '&resource=' + this.resource,
        //   {headers: headers}
        // ).subscribe(x => {
        //     const blob = new Blob([x], { type: 'application/vnd.ms-excel' });
        //     const url= window.URL.createObjectURL(blob);
        //     window.open(url);
        //   }
        // );
        //****
        return this.http.post(this.appUrl + 'excel', 'columns=' + this.repaircolumns(this.columns), { headers: headers }).subscribe(function (x) {
            var blob = new Blob([x], { type: 'application/vnd.ms-excel' });
            var url = window.URL.createObjectURL(blob);
            window.open(url);
        });
    };
    DataTableFooterComponent.prototype.exportPdf = function () {
        var token = this.cookieService.get('token');
        var headers = new http_2.Headers();
        headers.append('Content-Type', 'application/force-download');
        headers.append('Authorization', 'Bearer ' + token);
        return this.http.post(this.appUrl + 'pdf', 'type=' + 'pdf' +
            '&filters=' + JSON.stringify(this.filters) + '&columns=' + this.repaircolumns(this.columns) + '&sortDir=' + this.sortDir +
            '&sortProp=' + this.sortProp + '&includes=' + this.includes + '&resource=' + this.resource, { headers: headers }).subscribe(function (x) {
            // todo in test beshe
            var blob = new Blob([x], { type: 'application/vnd.ms-pdf' });
            var url = window.URL.createObjectURL(blob);
            window.open(url);
        });
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DataTableFooterComponent.prototype, "rows", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DataTableFooterComponent.prototype, "appUrl", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DataTableFooterComponent.prototype, "resource", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DataTableFooterComponent.prototype, "sortDir", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DataTableFooterComponent.prototype, "sortProp", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DataTableFooterComponent.prototype, "includes", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DataTableFooterComponent.prototype, "filters", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DataTableFooterComponent.prototype, "columns", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], DataTableFooterComponent.prototype, "footerHeight", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], DataTableFooterComponent.prototype, "rowCount", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], DataTableFooterComponent.prototype, "pageSize", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], DataTableFooterComponent.prototype, "offset", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DataTableFooterComponent.prototype, "pagerLeftArrowIcon", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DataTableFooterComponent.prototype, "pagerRightArrowIcon", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DataTableFooterComponent.prototype, "pagerPreviousIcon", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DataTableFooterComponent.prototype, "pagerNextIcon", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], DataTableFooterComponent.prototype, "totalMessage", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", core_1.TemplateRef)
    ], DataTableFooterComponent.prototype, "footerTemplate", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], DataTableFooterComponent.prototype, "selectedCount", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], DataTableFooterComponent.prototype, "selectedMessage", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], DataTableFooterComponent.prototype, "page", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], DataTableFooterComponent.prototype, "selectedValue", void 0);
    __decorate([
        core_1.ViewChild('selected'),
        __metadata("design:type", Object)
    ], DataTableFooterComponent.prototype, "selected", void 0);
    DataTableFooterComponent = __decorate([
        core_1.Component({
            selector: 'datatable-footer',
            template: "\n        <div\n                class=\"datatable-footer-inner\"\n                [ngClass]=\"{'selected-count': selectedMessage}\"\n                [style.height.px]=\"footerHeight\">\n            <ng-template\n                    *ngIf=\"footerTemplate\"\n                    [ngTemplateOutlet]=\"footerTemplate.template\"\n                    [ngTemplateOutletContext]=\"{ \n          rowCount: rowCount, \n          pageSize: pageSize, \n          selectedCount: selectedCount,\n          curPage: curPage,\n          offset: offset\n        }\">\n            </ng-template>\n            <div class=\"page-count\" *ngIf=\"!footerTemplate\">\n        <span *ngIf=\"selectedMessage\">\n          {{selectedCount.toLocaleString()}} {{selectedMessage}} /\n        </span>\n                {{rowCount.toLocaleString()}} {{totalMessage}}\n            </div>\n            <datatable-pager *ngIf=\"!footerTemplate\"\n                             [pagerLeftArrowIcon]=\"pagerLeftArrowIcon\"\n                             [pagerRightArrowIcon]=\"pagerRightArrowIcon\"\n                             [pagerPreviousIcon]=\"pagerPreviousIcon\"\n                             [pagerNextIcon]=\"pagerNextIcon\"\n                             [page]=\"curPage\"\n                             [size]=\"pageSize\"\n                             [count]=\"rowCount\"\n                             [hidden]=\"!isVisible\"\n                             (change)=\"page.emit($event)\">\n            </datatable-pager>\n            <ul style=\"display:flex ;   float: left;\">\n                <li style=\"display:   inline-block ;padding: 10px;;\">\n                    <select #selected (click)=\"onClick(selected.value)\">\n                        <option value=\"5\">5</option>\n                        <option value=\"10\">10</option>\n                        <option value=\"15\">15</option>\n                        <option value=\"20\">20</option>\n                    </select>\n                </li>\n                <li style=\"display:  inline-block;padding: 10px;\">\n                    <input type=\"image\" src=\"http://uupload.ir/files/b1dp_pdf.png\" height=\"18px\" (click)=\"exportPdf()\" \n                           style=\"height:18px ; width:18px\"/>\n                </li>\n                <li style=\"display: inline-block;     padding: 10px;\">\n                    <input type=\"image\" src=\"http://uupload.ir/files/v8vt_excel.png\" (click)=\"exportExcel()\" style=\"height:18px ; width:18px\" />\n                </li>\n            </ul>\n        </div>\n    ",
            host: {
                class: 'datatable-footer'
            },
            changeDetection: core_1.ChangeDetectionStrategy.OnPush
        }),
        __metadata("design:paramtypes", [http_1.Http,
            ngx_cookie_service_1.CookieService])
    ], DataTableFooterComponent);
    return DataTableFooterComponent;
}());
exports.DataTableFooterComponent = DataTableFooterComponent;
//# sourceMappingURL=footer.component.js.map